var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  SpecTransformer: () => SpecTransformer,
  buildJsonSchema: () => buildJsonSchema,
  buildJsonSchemas: () => buildJsonSchemas,
  register: () => register,
  withRefResolver: () => withRefResolver
});
module.exports = __toCommonJS(src_exports);

// src/JsonSchema.ts
var import_zod = require("zod");
var import_zod_to_json_schema = __toESM(require("zod-to-json-schema"));
var buildJsonSchema = (Type, schemaKey) => buildJsonSchemas({ [schemaKey]: Type }, { $id: schemaKey }).schemas[0];
var buildJsonSchemas = (models, opts = {}) => {
  const zodSchema = import_zod.z.object(models);
  const $id = opts.$id ?? `Schema`;
  const zodJsonSchema = (0, import_zod_to_json_schema.default)(zodSchema, {
    target: opts.target,
    basePath: [`${$id}#`]
  });
  const jsonSchema = __spreadValues({
    $id
  }, zodJsonSchema);
  const $ref = (key) => {
    const $ref2 = `${$id}#/properties/${typeof key === `string` ? key : key.key}`;
    return typeof key === `string` ? {
      $ref: $ref2
    } : {
      $ref: $ref2,
      description: key.description
    };
  };
  return {
    schemas: [jsonSchema],
    $ref
  };
};

// src/FastifyZod.ts
var import_swagger = __toESM(require("@fastify/swagger"));
var yaml = __toESM(require("js-yaml"));

// src/SpecTransformer.ts
var import_util2 = require("util");
var import_change_case = require("change-case");
var import_fast_deep_equal = __toESM(require("fast-deep-equal"));

// src/util.ts
var import_zod2 = require("zod");
var isRecord = (input) => !Array.isArray(input) && typeof input === `object` && input !== null;
var findFirstDeep = (current, predicate, path = []) => {
  if (predicate(current, path)) {
    return [true, current, path];
  }
  if (Array.isArray(current)) {
    for (let k = 0; k < current.length; k++) {
      path.push(`${k}`);
      const [found, value] = findFirstDeep(current[k], predicate, path);
      if (found) {
        return [found, value, path];
      }
      path.pop();
    }
    return [false, null, []];
  }
  if (isRecord(current)) {
    for (const k of Object.keys(current)) {
      path.push(k);
      const [found, value] = findFirstDeep(current[k], predicate, path);
      if (found) {
        return [found, value, path];
      }
      path.pop();
    }
    return [false, null, []];
  }
  return [false, null, []];
};
var visitDeep = (current, visit, path = []) => {
  visit(current, path);
  if (Array.isArray(current)) {
    for (let k = 0; k < current.length; k++) {
      path.push(`${k}`);
      visitDeep(current[k], visit, path);
      path.pop();
    }
    return;
  }
  if (isRecord(current)) {
    for (const k of Object.keys(current)) {
      path.push(k);
      visitDeep(current[k], visit, path);
      path.pop();
    }
    return;
  }
  return;
};

// src/Path.ts
var stringifyPath = (path) => path.join(`/`);
var equalPath = (a, b) => {
  if (a.length !== b.length) {
    return false;
  }
  for (let k = 0; k < a.length; k++) {
    if (a[k] !== b[k]) {
      return false;
    }
  }
  return true;
};
var getParentPath = (path) => {
  if (path.length === 0) {
    throw new Error(`path='${stringifyPath(path)}' has no parent`);
  }
  return path.slice(0, -1);
};
var getChildPath = (path, ...childPath) => [...path, ...childPath];
var getPathLastSegment = (path) => {
  if (path.length === 0) {
    throw new Error(`path='${stringifyPath}' has no parent`);
  }
  return path[path.length - 1];
};
var getChildSafe = (current, segment) => {
  if (Array.isArray(current)) {
    const index = parseInt(segment);
    if (!Number.isInteger(index)) {
      throw new Error(`current is an array but segment='${segment}' is not an integer`);
    }
    if (index < 0) {
      throw new Error(`current is an array but index='${index}' is negative`);
    }
    return [typeof current[index] !== void 0, current[index]];
  }
  if (isRecord(current)) {
    return [Object.keys(current).includes(segment), current[segment]];
  }
  return [false, void 0];
};
var getAtPathSafe = (obj, path) => {
  let current = obj;
  for (let k = 0; k < path.length; k++) {
    const [childFound, child] = getChildSafe(current, path[k]);
    if (!childFound) {
      if (k !== path.length - 1) {
        throw new Error(`parent(path='${stringifyPath(path)}') has no child at segment='${path[k]}'`);
      }
      return [false, void 0];
    }
    current = child;
  }
  return [true, current];
};
var getAtPath = (obj, path) => {
  const [found, value] = getAtPathSafe(obj, path);
  if (!found) {
    throw new Error(`value(path='${stringifyPath(path)}') not found`);
  }
  return value;
};
var setAtPath = (obj, path, value) => {
  const [parentFound, parent] = getAtPathSafe(obj, getParentPath(path));
  if (!parentFound) {
    throw new Error(`parent(path='${stringifyPath(path)}') not found`);
  }
  const key = getPathLastSegment(path);
  if (Array.isArray(parent)) {
    const index = parseInt(key);
    if (!Number.isInteger(index)) {
      throw new Error(`key(path='${stringifyPath(path)}', key='${key}') is not an integer`);
    }
    if (index < 0) {
      throw new Error(`index(path='${stringifyPath(path)}', index='${index}') is negative`);
    }
    if (index > parent.length) {
      throw new Error(`index(path='${stringifyPath(path)}', index='${index}') is out of bounds`);
    }
    if (index === parent.length) {
      parent.push(value);
    } else {
      parent[index] = value;
    }
  } else if (isRecord(parent)) {
    parent[key] = value;
  } else {
    throw new Error(`parent(path='${path}') is not an Array or a Record`);
  }
};
var deleteAtPath = (obj, path) => {
  const [parentFound, parent] = getAtPathSafe(obj, getParentPath(path));
  if (!parentFound) {
    throw new Error(`parent(path='${stringifyPath(path)}') not found`);
  }
  const key = getPathLastSegment(path);
  if (Array.isArray(parent)) {
    const index = parseInt(key);
    if (!Number.isInteger(index)) {
      throw new Error(`key(path='${stringifyPath(path)}', key='${key}') is not an integer`);
    }
    if (index !== parent.length) {
      throw new Error(`index(path='${stringifyPath(path)}', index='${index}') is invalid: only last item of parent array can be deleted`);
    }
    parent.pop();
  } else if (isRecord(parent)) {
    if (!Object.keys(parent).includes(key)) {
      throw new Error(`key(path='${stringifyPath(path)}', key='${key}') not found in parent`);
    }
    delete parent[key];
  } else {
    throw new Error(`parent(path='${stringifyPath(path)}') is not an Array or a Record`);
  }
};
var matchPathPrefix = (prefixPath, path) => {
  if (path.length < prefixPath.length) {
    return false;
  }
  for (let k = 0; k < prefixPath.length; k++) {
    if (path[k] !== prefixPath[k]) {
      return false;
    }
  }
  return true;
};
var replacePathPrefix = (prevPrefixPath, nextPrefixPath, path) => {
  if (!matchPathPrefix(prevPrefixPath, path)) {
    throw new Error(`path='${stringifyPath(path)}' doesn't match prevPrefixPath='${stringifyPath(prevPrefixPath)}'`);
  }
  return [...nextPrefixPath, ...path.slice(prevPrefixPath.length)];
};

// src/SpecTransformer.ts
var isRef = (ref) => {
  if (!isRecord(ref)) {
    return false;
  }
  return typeof ref.$ref === `string`;
};
var toRefPath = ($ref) => {
  const indexOfPath = $ref.indexOf(`#`);
  return {
    basePath: $ref.slice(0, indexOfPath),
    path: $ref.slice(indexOfPath + 1).split(`/`).slice(1)
  };
};
var toRef = (refPath) => ({
  $ref: [`${refPath.basePath}#`, ...refPath.path].join(`/`)
});
var isSpecSchema = (input) => {
  if (!isRecord(input)) {
    return false;
  }
  const { properties, additionalProperties, patternProperties, items } = input;
  if (typeof properties !== `undefined` && !isRecord(properties)) {
    return false;
  }
  if (typeof additionalProperties !== `undefined` && typeof additionalProperties !== `boolean` && !isRecord(additionalProperties)) {
    return false;
  }
  if (typeof patternProperties !== `undefined` && typeof patternProperties !== `boolean` && !isRecord(patternProperties)) {
    return false;
  }
  if (typeof items !== `undefined` && !isRecord(items)) {
    return false;
  }
  return true;
};
var isSpecSchemas = (input) => {
  if (!isRecord(input)) {
    return false;
  }
  for (const value of Object.values(input)) {
    if (!isSpecSchema(value)) {
      return false;
    }
  }
  return true;
};
var isOpenApiSpec = (input) => {
  if (!isRecord(input)) {
    return false;
  }
  const { components, paths } = input;
  if (!isRecord(components)) {
    return false;
  }
  const { schemas } = components;
  if (!isSpecSchemas(schemas)) {
    return false;
  }
  if (typeof paths !== `undefined` && !isRecord(paths)) {
    return false;
  }
  return true;
};
var isSwaggerSpec = (input) => {
  if (!isRecord(input)) {
    return false;
  }
  const { definitions, paths } = input;
  if (!isSpecSchemas(definitions)) {
    return false;
  }
  if (typeof paths !== `undefined` && !isRecord(paths)) {
    return false;
  }
  return true;
};
var isSpec = (input) => isOpenApiSpec(input) || isSwaggerSpec(input);
var deepClone = (spec) => JSON.parse(JSON.stringify(spec));
var defaultExtractSchemaPropertiesKey = [
  `properties`,
  `additionalProperties`,
  `patternProperties`,
  `items`
];
var withTimings = (fn) => {
  const begin = performance.now();
  const result = fn();
  const end = performance.now();
  return [
    result,
    {
      begin,
      end,
      delta: end - begin
    }
  ];
};
var SpecTransformer = class {
  constructor(spec, DEBUG = false) {
    this._DEBUG = (...args) => {
      if (this.DEBUG) {
        console.debug(...args);
      }
    };
    this.throw = (error) => {
      if (this.DEBUG) {
        console.debug((0, import_util2.inspect)(this.spec, { depth: null }));
        console.error(error);
      }
      throw error;
    };
    this.getSchemaPath = (schemaKey) => getChildPath(getChildPath(this.schemasPath, schemaKey));
    this.getSchema = (schemaKey) => {
      const schema = this.getAtPath(this.getSchemaPath(schemaKey));
      if (!isSpecSchema(schema)) {
        return this.throw(new Error(`schema is not a SpecSchema`));
      }
      return schema;
    };
    this.getSchemaKeys = () => {
      const schemas = this.getAtPath(this.schemasPath);
      if (!isRecord(schemas)) {
        return this.throw(new Error(`schemas is not a Record`));
      }
      return Object.keys(schemas);
    };
    this.createSchemaKey = (parentSchemaKey, path, schemaKeysOptions) => {
      const parts = [];
      if (!(schemaKeysOptions == null ? void 0 : schemaKeysOptions.removeInitialSchemasPrefix) || !this.initialSchemaKeys.includes(parentSchemaKey)) {
        parts.push(parentSchemaKey);
      }
      parts.push(...path);
      const baseName = parts.join(`_`);
      const schemaKey = (schemaKeysOptions == null ? void 0 : schemaKeysOptions.changeCase) === `PascalCase` ? (0, import_change_case.pascalCase)(baseName) : (schemaKeysOptions == null ? void 0 : schemaKeysOptions.changeCase) === `camelCase` ? (0, import_change_case.camelCase)(baseName) : (schemaKeysOptions == null ? void 0 : schemaKeysOptions.changeCase) === `param-case` ? (0, import_change_case.paramCase)(baseName) : (schemaKeysOptions == null ? void 0 : schemaKeysOptions.changeCase) === `snake_case` ? (0, import_change_case.snakeCase)(baseName) : baseName;
      if (this.getSchemaKeys().includes(schemaKey)) {
        throw new Error(`schemaKey(schemaKey='${schemaKey}') already exists`);
      }
      return schemaKey;
    };
    this.getAtPath = (path) => getAtPath(this.spec, path);
    this.getAtPathSafe = (path) => getAtPathSafe(this.spec, path);
    this.resolveRef = ($ref) => {
      const refPath = toRefPath($ref);
      if (refPath.basePath.length > 0) {
        const nextRef = toRef({
          basePath: ``,
          path: getChildPath(this.getSchemaPath(refPath.basePath), ...refPath.path)
        });
        return this.resolveRef(nextRef.$ref);
      }
      const value = this.getAtPath(refPath.path);
      if (isRef(value)) {
        return this.resolveRef(value.$ref);
      }
      return [value, $ref];
    };
    this.setAtPath = (path, value) => {
      this._DEBUG(`setAtPath`, { path, value });
      return setAtPath(this.spec, path, value);
    };
    this.deleteAtPath = (path) => {
      this._DEBUG(`deleteAtPath`, { path });
      return deleteAtPath(this.spec, path);
    };
    this.findFirstDeep = (predicate) => findFirstDeep(this.spec, predicate);
    this.hasProperRef = (schemaKey) => {
      const schemaPath = this.getSchemaPath(schemaKey);
      const [hasProperRef] = this.findFirstDeep((value, path) => {
        if (equalPath(path, schemaPath)) {
          return false;
        }
        if (isRef(value)) {
          const refPath = toRefPath(value.$ref);
          return refPath.basePath.length === 0 && matchPathPrefix(schemaPath, refPath.path);
        }
        return false;
      });
      return hasProperRef;
    };
    this.deleteUnusedSchemas = () => {
      this._DEBUG(`deleteUnusedSchemas`);
      let dirty = true;
      while (dirty) {
        dirty = false;
        for (const schemaKey of this.getSchemaKeys()) {
          if (!this.hasProperRef(schemaKey)) {
            this.deleteAtPath(this.getSchemaPath(schemaKey));
            dirty = true;
            break;
          }
        }
      }
    };
    this.rewriteSchemaAbsoluteRefs = (schemaKey) => {
      const schema = this.getSchema(schemaKey);
      const schemaPath = this.getSchemaPath(schemaKey);
      let dirty = false;
      visitDeep(schema, (value) => {
        if (isRef(value)) {
          const refPath = toRefPath(value.$ref);
          if (refPath.basePath.length === 0 && !matchPathPrefix(schemaPath, refPath.path)) {
            const nextPath = getChildPath(schemaPath, ...refPath.path);
            value.$ref = toRef({ basePath: ``, path: nextPath }).$ref;
            dirty = true;
          }
        }
      });
      return dirty;
    };
    this.rewriteSchemasAbsoluteRefs = () => {
      this._DEBUG(`rewriteSchemasAbsoluteRefs`);
      let dirty = true;
      while (dirty) {
        dirty = false;
        for (const schemaKey of this.getSchemaKeys()) {
          if (this.rewriteSchemaAbsoluteRefs(schemaKey)) {
            dirty = true;
            break;
          }
        }
      }
    };
    this.extractSchemaPathAsSchema = (prevSchemaKey, prevRelativePath, nextSchemaKey) => {
      const prevPath = getChildPath(this.getSchemaPath(prevSchemaKey), ...prevRelativePath);
      const prevValue = this.getAtPath(prevPath);
      const nextPath = this.getSchemaPath(nextSchemaKey);
      const [hasValueAtNextPath, valueAtNextPath] = this.getAtPathSafe(nextPath);
      if (hasValueAtNextPath) {
        if (!(0, import_fast_deep_equal.default)(prevValue, valueAtNextPath)) {
          this.throw(new Error(`schema(schemaKey='${nextSchemaKey}') already exists with a different value`));
        }
      } else {
        this.setAtPath(nextPath, prevValue);
      }
      this.setAtPath(prevPath, toRef({ basePath: ``, path: nextPath }));
      let dirty = false;
      visitDeep(this.spec, (value) => {
        if (isRef(value)) {
          const refPath = toRefPath(value.$ref);
          if (refPath.basePath.length === 0 && matchPathPrefix(prevPath, refPath.path)) {
            value.$ref = toRef({
              basePath: ``,
              path: replacePathPrefix(prevPath, nextPath, refPath.path)
            }).$ref;
            dirty = true;
          }
        }
      });
      return dirty;
    };
    this.extractSchemaPropertiesAtKey = (parentSchemaKey, propertiesKey, schemaKeysOptions) => {
      let globalDirty = false;
      let dirty = true;
      while (dirty) {
        dirty = false;
        if (propertiesKey === `properties` || propertiesKey === `additionalProperties` || propertiesKey === `patternProperties`) {
          const properties = this.getSchema(parentSchemaKey)[propertiesKey];
          if (isRecord(properties)) {
            for (const k of Object.keys(properties)) {
              const property = properties[k];
              if (!isRef(property)) {
                const nextSchemaKey = this.createSchemaKey(parentSchemaKey, [`${k}`], schemaKeysOptions);
                this.extractSchemaPathAsSchema(parentSchemaKey, [propertiesKey, k], nextSchemaKey);
                dirty = true;
                break;
              }
            }
          }
        }
        if (propertiesKey === `items`) {
          const properties = this.getSchema(parentSchemaKey)[propertiesKey];
          if (isRecord(properties) && !isRef(properties)) {
            const nextSchemaKey = this.createSchemaKey(parentSchemaKey, [`item`], schemaKeysOptions);
            this.extractSchemaPathAsSchema(parentSchemaKey, [`items`], nextSchemaKey);
            dirty = true;
          }
        }
        if (dirty) {
          globalDirty = true;
        }
      }
      return globalDirty;
    };
    this.extractSchemaProperties = (schemaKey, propertiesKeys, schemaKeysOptions) => {
      let globalDirty = false;
      let dirty = true;
      while (dirty) {
        dirty = false;
        for (const propertiesKey of propertiesKeys) {
          if (this.extractSchemaPropertiesAtKey(schemaKey, propertiesKey, schemaKeysOptions)) {
            dirty = true;
          }
        }
        if (dirty) {
          globalDirty = true;
        }
      }
      for (const propertiesKey of propertiesKeys) {
        if (this.extractSchemaPropertiesAtKey(schemaKey, propertiesKey, schemaKeysOptions)) {
          this.extractSchemaProperties(schemaKey, propertiesKeys, schemaKeysOptions);
          return true;
        }
      }
      return globalDirty;
    };
    this.extractSchemasProperties = (propertiesKeys, schemaKeysOptions) => {
      this._DEBUG(`extractSchemasProperties`);
      let dirty = true;
      while (dirty) {
        dirty = false;
        for (const schemaKey of this.getSchemaKeys()) {
          if (this.extractSchemaProperties(schemaKey, propertiesKeys, schemaKeysOptions)) {
            dirty = true;
            break;
          }
        }
      }
    };
    this.mergeRef = (prev$ref) => {
      const [schema, next$ref] = this.resolveRef(prev$ref);
      let globalDirty = false;
      let dirty = true;
      while (dirty) {
        dirty = false;
        visitDeep(this.spec, (value, path) => {
          if (value !== schema && (0, import_fast_deep_equal.default)(value, schema)) {
            this.setAtPath(path, {
              $ref: next$ref
            });
            dirty = true;
          }
        });
        if (dirty) {
          globalDirty = true;
        }
      }
      return globalDirty;
    };
    this.mergeRefs = ($refs) => {
      let dirty = true;
      while (dirty) {
        dirty = false;
        for (const $ref of $refs) {
          if (this.mergeRef($ref)) {
            dirty = true;
            break;
          }
        }
      }
    };
    this.transformWithTimings = (opts = {}) => {
      const [
        {
          rewriteSchemasAbsoluteRefs,
          extractSchemasProperties,
          mergeRefs,
          deleteUnusedSchemas
        },
        total
      ] = withTimings(() => {
        const [, rewriteSchemasAbsoluteRefs2] = withTimings(() => {
          if (opts.rewriteSchemasAbsoluteRefs === false) {
            return;
          }
          this.rewriteSchemasAbsoluteRefs();
        });
        const [, mergeRefs2] = withTimings(() => {
          if (opts.mergeRefs) {
            this.mergeRefs(opts.mergeRefs.map((ref) => ref.$ref));
          }
        });
        this._DEBUG({ mergeRefs: mergeRefs2 });
        this._DEBUG({ rewriteSchemasAbsoluteRefs: rewriteSchemasAbsoluteRefs2 });
        const [, extractSchemasProperties2] = withTimings(() => {
          if (opts.extractSchemasProperties === false) {
            return;
          }
          const extractSchemasPropertiesKeys = !Array.isArray(opts.extractSchemasProperties) ? defaultExtractSchemaPropertiesKey : opts.extractSchemasProperties;
          this.extractSchemasProperties(extractSchemasPropertiesKeys, opts.schemaKeys);
        });
        this._DEBUG({ extractSchemasProperties: extractSchemasProperties2 });
        const [, deleteUnusedSchemas2] = withTimings(() => {
          if (opts.deleteUnusedSchemas === false) {
            return;
          }
          this.deleteUnusedSchemas();
        });
        this._DEBUG({ deleteUnusedSchemas: deleteUnusedSchemas2 });
        return {
          rewriteSchemasAbsoluteRefs: rewriteSchemasAbsoluteRefs2,
          extractSchemasProperties: extractSchemasProperties2,
          mergeRefs: mergeRefs2,
          deleteUnusedSchemas: deleteUnusedSchemas2
        };
      });
      this._DEBUG({ total });
      return {
        spec: this.spec,
        timings: {
          rewriteSchemasAbsoluteRefs,
          extractSchemasProperties,
          mergeRefs,
          deleteUnusedSchemas,
          total
        }
      };
    };
    this.transform = (opts = {}) => this.transformWithTimings(opts).spec;
    if (!isSpec(spec)) {
      throw new Error(`spec is not an OpenApiSpec or a SwaggerSpec`);
    }
    this.spec = deepClone(spec);
    this.schemasPath = isOpenApiSpec(spec) ? [`components`, `schemas`] : [`definitions`];
    this.initialSchemaKeys = this.getSchemaKeys();
    this.DEBUG = DEBUG;
  }
};

// src/FastifyZod.ts
var withRefResolver = (options) => __spreadProps(__spreadValues({}, options), {
  refResolver: __spreadProps(__spreadValues({}, options.refResolver), {
    clone: true,
    buildLocalReference: (json, _baseUri, _fragment, i) => typeof json.$id === `string` ? json.$id : `def-${i}`
  })
});
var register = (f, { jsonSchemas: { schemas, $ref }, swaggerOptions }) => {
  for (const schema of schemas) {
    f.addSchema(schema);
  }
  if (swaggerOptions) {
    const _a = swaggerOptions, { transformSpec } = _a, baseSwaggerOptions = __objRest(_a, ["transformSpec"]);
    f.register(import_swagger.default, withRefResolver(baseSwaggerOptions));
    if (transformSpec) {
      const originalRoutePrefix = baseSwaggerOptions.routePrefix ?? `/documentation`;
      const transformedRoutePrefix = transformSpec.routePrefix ?? `${originalRoutePrefix}_transformed`;
      const fetchTransformedSpec = async () => {
        const originalSpec = await f.inject({
          method: `get`,
          url: `${baseSwaggerOptions.routePrefix ?? `documentation`}/json`
        }).then((res) => res.json());
        const t = new SpecTransformer(originalSpec);
        return t.transform(transformSpec.options);
      };
      let cachedTransformedSpec = null;
      const getTransformedSpec = async () => {
        if (!transformSpec.cache) {
          return await fetchTransformedSpec();
        }
        if (!cachedTransformedSpec) {
          cachedTransformedSpec = fetchTransformedSpec();
        }
        return await cachedTransformedSpec;
      };
      let cachedTransformedSpecJson = null;
      const getTransformedSpecJson = async () => {
        const transformedSpec = await getTransformedSpec();
        if (!transformSpec.cache) {
          return JSON.stringify(transformedSpec, null, 2);
        }
        if (!cachedTransformedSpecJson) {
          cachedTransformedSpecJson = JSON.stringify(transformedSpec, null, 2);
        }
        return cachedTransformedSpecJson;
      };
      let cachedTransformedSpecYaml = null;
      const getTransformedSpecYaml = async () => {
        const transformedSpec = await getTransformedSpec();
        if (!transformSpec.cache) {
          return yaml.dump(transformedSpec);
        }
        if (!cachedTransformedSpecYaml) {
          cachedTransformedSpecYaml = yaml.dump(transformedSpec);
        }
        return cachedTransformedSpecYaml;
      };
      f.get(`${transformedRoutePrefix}/json`, async (_request, reply) => {
        reply.type(`application/json`);
        return await getTransformedSpecJson();
      });
      f.get(`${transformedRoutePrefix}/yaml`, async (_request, reply) => {
        reply.type(`text/x-yaml`);
        return await getTransformedSpecYaml();
      });
    }
  }
  const addRoute = (_b) => {
    var _c = _b, {
      method,
      url,
      operationId,
      params,
      body,
      reply,
      querystring,
      handler
    } = _c, fastifySchema = __objRest(_c, [
      "method",
      "url",
      "operationId",
      "params",
      "body",
      "reply",
      "querystring",
      "handler"
    ]);
    f[method](url, {
      schema: __spreadValues({
        operationId,
        params: params ? $ref(params) : void 0,
        body: body ? $ref(body) : void 0,
        querystring: querystring ? $ref(querystring) : void 0,
        response: reply ? {
          200: $ref(reply)
        } : void 0
      }, fastifySchema)
    }, handler);
  };
  const createAddRoute = (method) => (url, config, handler) => addRoute(__spreadValues({ url, handler, method }, config));
  const pluginInstance = {
    delete: createAddRoute(`delete`),
    get: createAddRoute(`get`),
    head: createAddRoute(`head`),
    options: createAddRoute(`options`),
    patch: createAddRoute(`patch`),
    post: createAddRoute(`post`),
    put: createAddRoute(`put`)
  };
  f.decorate(`zod`, pluginInstance);
  return f;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SpecTransformer,
  buildJsonSchema,
  buildJsonSchemas,
  register,
  withRefResolver
});
